#include <stdio.h>
#include <stdbool.h>
#include <ctype.h>

// Πρακτική 1
bool isSameLetter(char a, char b, bool caseInsensitive) {
    // Α τρόπος - Πιο σωστός/απλός τρόπος, λίγο δυσκολότερος στη σύλληψη

    // εάν θέλουμε να φαίνονται τα πεζά με τα κεφαλαία το ίδιο
    if (caseInsensitive == true) {
        // η διαφορά που αν προσθέσεις στον κωδικό κεφαλαίου
        // χαρακτήρα προκύπτει ο κωδικός του πεζού
        char small2caps = 'a' - 'A';

        // τότε ας κάνουμε και τους δύο χαρακτήρες πεζούς

        // εάν ο a είναι κεφαλαίος
        if (isupper(a)) {
            // κάντον πεζό
            a += small2caps;
        }
        // εάν ο b είναι κεφαλαίος
        if (isupper(b)) {
            // κάντον πεζό
            b += small2caps;
        }
    }

    // συγκρίνουμε τους χαρακτήρες και
    // επιστρέφουμε τον αν είναι ίδιοι
    // (αν έχουν τον ίδιο κωδικό)
    return (a == b);

    // Β τρόπος - Πιο διεξοδικός - κάπως κουραστικός στην υλοποίηση - ταχύτερος στην εκτέλεση

    // εάν τα κεφαλαία και τα πεζά θεωρούνται διαφορετικά
    if (caseInsensitive == false) {
        // αρκεί η σύγκριση των κωδικών
        if (a == b) {
            return true;
        } else {
            return false;
        }
        // αυτό θα μπορούσε να γραφεί συνοπτικά ως: return (a == b);
    } else {
        // αλλιώς τα πεζά και τα κεφαλαία τα θεωρούμε ίδια

        // η διαφορά που αν προσθέσεις στον κωδικό κεφαλαίου
        // χαρακτήρα προκύπτει ο κωδικός του πεζού
        char small2caps = 'a' - 'A';
        // εάν το a είναι κεφαλαίο
        if (isupper(a)) {
            // εάν και το b είναι κεφαλαίο
            if (isupper(b)) {
                // αρκεί η σύγκριση των κωδικών
                return (a == b);
            } else {
                // εάν το b είναι πεζό, μετατρέπω και το a σε πεζό
                a += small2caps;
                // και συγκρίνω απλά τους κωδικούς
                return (a == b);
            }
        } else {
            // αφού το a είναι πεζό

            // εάν το b είναι κεφαλαίο
            if (isupper(b)) {
                // το μετατρέπω σε πεζό
                b += small2caps;
            }
            // σε κάθε περίπτωση συγκρίνω απλά τους κωδικούς
            return (a == b);
        }
    }
}

// Πρακτική 2
bool copyText(char from[], char to[], int lengthOfTo) {
    //
    for (int i = 0; i < lengthOfTo; ++i) {
        to[i] = from[i];
        if (from[i] == 0) {
            return true;
        }
    }
    to[lengthOfTo-1] = 0;
    return false;
}

int main(void) {
    printf("%d %d %d %d %d %d %d %d %d %d\n\n\n",
           isSameLetter('a','b',true),
           isSameLetter('a','b',false),
           isSameLetter('c','c',true),
           isSameLetter('c','c',false),
           isSameLetter('E','e',true),
           isSameLetter('E','e',false),
           isSameLetter('g','G',true),
           isSameLetter('g','G',false),
           isSameLetter('Q','Q',true),
           isSameLetter('Q','Q',false)
    );

    char oldText[] = "This is a test";
    #define N 100
    char newText[N];    // κείμενο με "τυχαίο"/άγνωστο περιεχόμενο
    newText[N-1] = 0;   // βάζω στο τέλος του τον κωδικό 0 ώστε να
                        // μπορώ να το εκτυπώσω όπως είναι αρχικά
    #define n 10
    char smallText[n];  // μικρός πίνακας που δεν χωράει το αρχικό
                        // κείμενο
    bool copyResult;

    // εμφανίζω την αρχική κατάσταση
    printf("Old: %s\nNew: %s\n\n", oldText, newText);

    // αντιγράφω
    copyResult = copyText(oldText, newText, N);

    // εμφανίζω τη νέα κατάσταση
    printf("Old: %s\nNew: %s\nSuccessfull copy: %s\n\n", oldText, newText, copyResult?"Ok":"Failed");

    // αντιγράφω
    copyResult = copyText(oldText, smallText, n);

    // εμφανίζω τη νέα κατάσταση
    printf("  Old: %s\nSmall: %s\nSuccessfull copy: %s\n\n", oldText, smallText, copyResult?"Ok":"Failed");

    return 0;
}
