#include <stdio.h>
#include <ctype.h>

typedef struct _apoint {
    double x;
    double y;
} Point;

Point calcCenterPoint(int N, Point points[N]) {
    // ορίζουμε ένα σημείο που θα είναι το κέτρο βάρους
    Point center;
    // μηδενίζουμε τις συντεταγμένες για να αθροίσουμε
    // σε αυτές τις συντεταγμένες των κορυφών
    center.x = 0.0;
    center.y = 0.0;
    // για κάθε κορυφή
    for (int i = 0; i < N; ++i) {
        // προσθέτουμε τις συντεταγμένες της σε αυτές του κέντρου
        center.x += points[i].x;
        center.y += points[i].y;
    }
    // διαιρούμε με το πλήθος των κορυφών ώστε να βρεθεί το
    // κέντρο βάρους (δηλαδή ο μέσος όρος)
    center.x /= N;
    center.y /= N;

    // επιστρέφουμε το σημείο που υπολογίστηκε
    return center;
}

// Πρακτική 3
// Ορισμός της δομής που για μια λέξη σε ένα κείμενο έχει
typedef struct _word {
    // τη θέση της αρχής της στο κείμενο
    int index;
    // το μήκος της
    int length;
} Word;

Word getFirstWord(char text[], int startIndex) {
    // έστω ότι δε βρήκα λέξη (αυτά περιγράφει η εκφώνηση
    // οτι πρέπει να επιστραφούν αν ΔΕΝ βρεθεί λέξη)
    Word word = {
            .index = -1,
            .length = -1
    };

    // δηλώνω τη μεταβλητή i πριν το for ώστε να
    // έχω πρόσβαση στο περιεχόμενό της και μετά
    int i;
    // για κάθε χαρακτήρα,
    // μέχρι να βρεθεί ο κωδικός 0 (δηλαδή το τέρμα του κειμένου)
    for (i = startIndex; text[i] != 0; ++i) {
        // εάν είναι αλφαβητικός και δεν έχω βρει λέξη μέχρι τώρα
        if (isalpha(text[i]) && word.index == -1) {
            // από "εδώ" ξεκινάει η λέξη
            word.index = i;
        }
        // εάν έχει βρεθεί λέξη και δεν είναι αλφαβητικός χαρακτήρας
        if (word.index != -1 && !isalpha(text[i])) {
            // τότε βρέθηκε και το τέλος της λέξης
            // οπότε το μήκος της είναι
            word.length = i - word.index;
            // η λέξη βρέθηκε επιτυχώς και επιστρέφεται το αποτέλεσμα
            return word;
        }
    }
    // τελείωσε το κείμενο χωρίς να έχει βρεθεί τέλος
    // (ή και ούτε καν η αρχή) της λέξης

    // εάν έχει βρεθεί λέξη
    if (word.index != -1) {
        // τότε υπολογίζεται το μήκος της
        word.length = i - word.index;
    }

    // επιστρέφουμε τη λέξη έτσι και αλλιώς
    return word;
}

int main(void) {
    printf("Hello, World!\n");
    Word w = getFirstWord("This is a test for all", 18);
    printf("Index: %d\nLength: %d\n", w.index, w.length);

    return 0;
}
